import java.util.*;

class GenericSet<E> {
	public GenericSet() {
		this.theElements = new Vector<E>();
	}

	public boolean isEmpty() {
		return this.theElements.isEmpty();
	}

	public int size() {
		return this.theElements.size();
	}

	Iterator<E> iterator() {
		return this.theElements.iterator();
	}

	public boolean contains(E o) {
		Iterator<E> it = this.iterator();
		while (it.hasNext()) {
			Object elem = it.next();
			if (elem.equals(o)) {
				return true;
			}
		}
		return false;
	}

	public void addElement(E o) {
		if (!this.contains(o)) {
			this.theElements.addElement(o);
		}
	}

	public GenericSet<E> copy() {
		GenericSet<E> destSet = new GenericSet<E>();
		Iterator<E> it = this.iterator();
		while (it.hasNext()) {
			destSet.addElement(it.next());
		}
		return destSet;
	}

	public GenericSet<E> union(GenericSet<E> s) {
		GenericSet<E> unionSet = s.copy();
		Iterator<E> it = this.iterator();
		while (it.hasNext()) {
			unionSet.addElement(it.next());
		}
		return unionSet;
	}

	public GenericSet<E> intersection(GenericSet<E> s) {
		GenericSet<E> interSet = new GenericSet<E>();
		Iterator<E> it = this.iterator();
		while (it.hasNext()) {
			E elem = it.next();
			if (s.contains(elem)) {
				interSet.addElement(elem);
			}
		}
		return interSet;
	}

	void removeAllElements() {
		this.theElements.removeAllElements();
	}

	public String toString() {
		String s = "[";
		Iterator<E> it = this.iterator();
		if (it.hasNext()) {
			s += it.next().toString();
		}
		while (it.hasNext()) {
			s += ", " + it.next().toString();
		}
		return s + "]";
	}

	private Vector<E> theElements;
}
